/**
 * This file is part of GenomeView, a genome browser and annotation curator
 * 
 * Copyright (C) 2007-2017 Thomas Abeel and contributors
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 * Project: http://genomeview.org/
 */
package net.sf.jannot.refseq;

import net.sf.jannot.refseq.FaidxIndex.IndexEntry;
import net.sf.samtools.seekablestream.SeekableStream;


/**
 * 
 * @author Thomas Abeel
 *
 */
public class FaidxData extends Sequence {


	private SeekableStream data = null;
	private IndexEntry idx;

	
	/**
	 * @param index
	 * @param content
	 * @param name
	 */
	public FaidxData(FaidxIndex index, SeekableStream content, String name) {

		this.data = content;
		this.idx = index.get(name);


	}

	@Override
	public Iterable<Character> get(int start, int end) {
		return new FaixDataIterable(data, start, end-1, idx.start, idx.len, idx.lineLen, idx.byteLen);
	}

	@Override
	public Iterable<Character> get() {
		return get(1,(int)(idx.len+1));
		//return new FaixDataIterable(data, 1, (int) this.len, this.start, this.len, this.lineLen, this.byteLen);
	}

	@Override
	public int size() {
		return (int) idx.len;
	}

}
